'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Hooks = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const debug = require('debug')('cli-engine:hooks');

class Hooks {

  constructor({ config }) {
    this.config = config;
  }

  async run(event, options = {}) {
    let scripts = this.config.hooks[event];
    if (!scripts) return;
    for (let script of scripts) {
      script = _path2.default.join(this.config.root, script);
      debug(`%s %s`, event, script);
      const m = require(script);
      await m(this.config, options);
    }
  }
}
exports.Hooks = Hooks;